{
  This file was automatically generated on 2013-01-25.

  Bindings Version 2.0.1

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletPTC;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_PTC_DEVICE_IDENTIFIER = 226;

  BRICKLET_PTC_FUNCTION_GET_TEMPERATURE = 1;
  BRICKLET_PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;
  BRICKLET_PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;
  BRICKLET_PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;
  BRICKLET_PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;
  BRICKLET_PTC_FUNCTION_SET_DEBOUNCE_PERIOD = 6;
  BRICKLET_PTC_FUNCTION_GET_DEBOUNCE_PERIOD = 7;
  BRICKLET_PTC_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_PTC_CALLBACK_TEMPERATURE = 8;
  BRICKLET_PTC_CALLBACK_TEMPERATURE_REACHED = 9;

  BRICKLET_PTC_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_PTC_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_PTC_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_PTC_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_PTC_THRESHOLD_OPTION_GREATER = '>';

type
  TArray0To2OfUInt8 = array [0..2] of byte;

  TBrickletPTC = class;
  TBrickletPTCNotifyTemperature = procedure(sender: TBrickletPTC; const temperature: longint) of object;
  TBrickletPTCNotifyTemperatureReached = procedure(sender: TBrickletPTC; const temperature: longint) of object;

  /// <summary>
  ///  Device for reading temperatures from Pt100 or Pt1000 sensors
  /// </summary>
  TBrickletPTC = class(TDevice)
  private
    temperatureCallback: TBrickletPTCNotifyTemperature;
    temperatureReachedCallback: TBrickletPTCNotifyTemperatureReached;
  protected
    procedure CallbackWrapperTemperature(const packet: TByteArray); virtual;
    procedure CallbackWrapperTemperatureReached(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  TODO
    ///  
    ///  If you want to get the temperature periodically, it is recommended 
    ///  to use the callback <see cref="BrickletPTC.TBrickletPTC.Temperature"/> and set the period with 
    ///  <see cref="BrickletPTC.TBrickletPTC.SetTemperatureCallbackPeriod"/>.
    /// </summary>
    function GetTemperature: longint; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickletPTC.TBrickletPTC.Temperature"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  <see cref="BrickletPTC.TBrickletPTC.Temperature"/> is only triggered if the temperature has changed since the
    ///  last triggering.
    ///  
    ///  The default value is 0.
    /// </summary>
    procedure SetTemperatureCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletPTC.TBrickletPTC.SetTemperatureCallbackPeriod"/>.
    /// </summary>
    function GetTemperatureCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletPTC.TBrickletPTC.TemperatureReached"/> callback. 
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  The default value is ('x', 0, 0).
    /// </summary>
    procedure SetTemperatureCallbackThreshold(const option: char; const min: longint; const max: longint); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletPTC.TBrickletPTC.SetTemperatureCallbackThreshold"/>.
    /// </summary>
    procedure GetTemperatureCallbackThreshold(out option: char; out min: longint; out max: longint); virtual;

    /// <summary>
    ///  Sets the period in ms with which the threshold callback
    ///  
    ///   <see cref="BrickletPTC.TBrickletPTC.TemperatureReached"/>
    ///  
    ///  is triggered, if the threshold
    ///  
    ///   <see cref="BrickletPTC.TBrickletPTC.SetTemperatureCallbackThreshold"/>
    ///  
    ///  keeps being reached.
    ///  
    ///  The default value is 100.
    /// </summary>
    procedure SetDebouncePeriod(const debounce: longword); virtual;

    /// <summary>
    ///  Returns the debounce period as set by <see cref="BrickletPTC.TBrickletPTC.SetDebouncePeriod"/>.
    /// </summary>
    function GetDebouncePeriod: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to, 
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifiers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  
    ///  .. versionadded:: 2.0.0~(Plugin)
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TArray0To2OfUInt8; out firmwareVersion: TArray0To2OfUInt8; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletPTC.TBrickletPTC.SetTemperatureCallbackPeriod"/>. The parameter is the temperature
    ///  of the sensor.
    ///  
    ///  <see cref="BrickletPTC.TBrickletPTC.Temperature"/> is only triggered if the temperature has changed since the
    ///  last triggering.
    /// </summary>
    property OnTemperature: TBrickletPTCNotifyTemperature read temperatureCallback write temperatureCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletPTC.TBrickletPTC.SetTemperatureCallbackThreshold"/> is reached.
    ///  The parameter is the temperature of the sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletPTC.TBrickletPTC.SetDebouncePeriod"/>.
    /// </summary>
    property OnTemperatureReached: TBrickletPTCNotifyTemperatureReached read temperatureReachedCallback write temperatureReachedCallback;
  end;

implementation

constructor TBrickletPTC.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_PTC_FUNCTION_GET_TEMPERATURE] := RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] := RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] := RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] := RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] := RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PTC_FUNCTION_SET_DEBOUNCE_PERIOD] := RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_PTC_FUNCTION_GET_DEBOUNCE_PERIOD] := RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PTC_CALLBACK_TEMPERATURE] := RESPONSE_EXPECTED_ALWAYS_FALSE;
  responseExpected[BRICKLET_PTC_CALLBACK_TEMPERATURE_REACHED] := RESPONSE_EXPECTED_ALWAYS_FALSE;
  responseExpected[BRICKLET_PTC_FUNCTION_GET_IDENTITY] := RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_PTC_CALLBACK_TEMPERATURE] := {$ifdef FPC}@{$endif}CallbackWrapperTemperature;
  callbackWrappers[BRICKLET_PTC_CALLBACK_TEMPERATURE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperTemperatureReached;
end;

function TBrickletPTC.GetTemperature: longint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_GET_TEMPERATURE, 8);
  response := SendRequest(request);
  result := LEConvertInt32From(8, response);
end;

procedure TBrickletPTC.SetTemperatureCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request);
end;

function TBrickletPTC.GetTemperatureCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletPTC.SetTemperatureCallbackThreshold(const option: char; const min: longint; const max: longint);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, 17);
  LEConvertCharTo(option, 8, request);
  LEConvertInt32To(min, 9, request);
  LEConvertInt32To(max, 13, request);
  SendRequest(request);
end;

procedure TBrickletPTC.GetTemperatureCallbackThreshold(out option: char; out min: longint; out max: longint);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, 8);
  response := SendRequest(request);
  option := LEConvertCharFrom(8, response);
  min := LEConvertInt32From(9, response);
  max := LEConvertInt32From(13, response);
end;

procedure TBrickletPTC.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_SET_DEBOUNCE_PERIOD, 12);
  LEConvertUInt32To(debounce, 8, request);
  SendRequest(request);
end;

function TBrickletPTC.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_GET_DEBOUNCE_PERIOD, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletPTC.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TArray0To2OfUInt8; out firmwareVersion: TArray0To2OfUInt8; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreatePacket(self, BRICKLET_PTC_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletPTC.CallbackWrapperTemperature(const packet: TByteArray);
var temperature: longint;
begin
  if (Assigned(temperatureCallback)) then begin
    temperature := LEConvertInt32From(8, packet);
    temperatureCallback(self, temperature);
  end;
end;

procedure TBrickletPTC.CallbackWrapperTemperatureReached(const packet: TByteArray);
var temperature: longint;
begin
  if (Assigned(temperatureReachedCallback)) then begin
    temperature := LEConvertInt32From(8, packet);
    temperatureReachedCallback(self, temperature);
  end;
end;

end.
